-- page : add 4
SELECT filename, (ST_MetaData(rast)).* FROM raster_add1 ;

-- page : add 5
WITH a AS (
	SELECT ST_SetSrid(ST_Point(139.939, 35.902), 4326) geom
)
SELECT filename, ST_Value(rast, 1, geom) FROM a, raster_add1 ;

-- page : add 5 (2)
COPY (
	WITH a (rce) AS (
		VALUES (ARRAY[
			'[20-70:255,   [70-80:255-0, [80-:0',
			'[20-70:0-255, [70-80:255-0, [80-:0',
			'[20-70:0-255, [70-:255'])
	), b AS (
		SELECT ST_UpperLeftX(rast) :: int x, ST_UpperLeftY(rast) :: int y, rast
		FROM raster_add1
	)
	SELECT concat('<img style="position:absolute; width:200px; height:200px; left:',
		(x - 120) * 20 :: float, 'px; top:', (50 - y) * 20 :: float,
		'px" src="data:image/png;base64,',
		replace(encode(ST_AsPNG(ST_AddBand(NULL, ARRAY[
			ST_Reclass(rast, 1, rce[1], text '8BUI', 255)
			, ST_Reclass(rast, 1, rce[2], text '8BUI', 255)
			, ST_Reclass(rast, 1, rce[3], text '8BUI', 255)
			])), 'base64'), E'\n', ''), '" />')
	FROM a, b
) TO 'C:/Program Files/PostgreSQL/9.3/data/add1_output.htm' ;
