-- page : add 7
CREATE TABLE data_add2 (mesh3 text, val1 int, val2 int, val3 int) ;
COPY data_add2 FROM 'C:/Program Files/PostgreSQL/9.3/data/add2_meshdata.tsv' ;

-- page : add 8
SELECT min(val1), max(val1),
	min(val2), max(val2),
	min(val3), max(val3)
FROM data_add2 ;

-- page : add 8 (2)
SELECT DISTINCT substr(mesh3, 3, 2) :: float8 + 100 AS upperleftx,
	(substr(mesh3, 1, 2) :: float8 + 1) * 2 / 3 AS upperlefty
FROM data_add2 ;

-- page : add 9
WITH a AS (
	SELECT DISTINCT substr(mesh3, 3, 2) :: float8 + 100 AS upperleftx,
		(substr(mesh3, 1, 2) :: float8 + 1) * 2 / 3 AS upperlefty
	FROM data_add2
)
SELECT ST_AddBand(
	ST_MakeEmptyRaster(
		80, 80, upperleftx, upperlefty,
		1 :: float8 / 80,
		-2 :: float8 / 3 / 80, 0, 0, 4612),
	text '32BSI', -100, -1) rast
FROM a;

-- page : add 9 (2)
SELECT mesh3,
	substr(mesh3, 6, 1) :: int * 10 + substr(mesh3, 8, 1) :: int + 1 AS x,
	80 - (substr(mesh3, 5, 1) :: int * 10 + substr(mesh3, 7, 1) :: int) AS y,
	val1, val1, val2
FROM data_add2 ;

-- page : add 10
WITH a AS (
	SELECT * FROM generate_series(1, 80) AS foo (x), generate_series(1, 80) AS bar (y)
), b AS (
	SELECT mesh3,
		substr(mesh3, 6, 1) :: int * 10 + substr(mesh3, 8, 1) :: int + 1 AS x,
		80 - (substr(mesh3, 5, 1) :: int * 10 + substr(mesh3, 7, 1) :: int) AS y,
		val1
	FROM data_add2
), c AS (
	SELECT y, array_agg(val) AS ary
	FROM (
		SELECT x, y, coalesce(val1, -1) AS val
		FROM a LEFT JOIN b USING (x, y)
		ORDER BY y, x
	) AS foo
	GROUP BY y
)
SELECT ('{' || string_agg(tmp, ',') || '}') :: int[][]
FROM (
	SELECT '{' || array_to_string(ary, ',') || '}' AS tmp FROM c ORDER BY y
) foo ;

-- page : add 11
CREATE TABLE raster_add2 AS
WITH t AS (
	SELECT mesh3, val1 AS val FROM data_add2
), a AS (
	SELECT * FROM generate_series(1, 80) AS foo (x), generate_series(1, 80) AS bar (y)
), b AS (
	SELECT mesh3,
		substr(mesh3, 6, 1) :: int * 10 + substr(mesh3, 8, 1) :: int + 1 AS x,
		80 - (substr(mesh3, 5, 1) :: int * 10 + substr(mesh3, 7, 1) :: int) AS y,
		val
	FROM t
), c AS (
	SELECT y, array_agg(val) AS ary
	FROM (
		SELECT x, y, coalesce(val, -1) AS val
		FROM a LEFT JOIN b USING (x, y)
		ORDER BY y, x
	) foo
	GROUP BY y
), d AS (
	SELECT ('{' || string_agg(tmp, ',') || '}') :: int[][] AS dat_ary
	FROM (
		SELECT '{' || array_to_string(ary, ',') || '}' AS tmp FROM c ORDER BY y
	) AS foo
), r1 AS (
	SELECT DISTINCT substr(mesh3, 3, 2) :: float8 + 100 AS upperleftx,
		(substr(mesh3, 1, 2) :: float8 + 1) * 2 / 3 AS upperlefty
	FROM t
), r2 AS (
	SELECT ST_AddBand(
		ST_MakeEmptyRaster(
			80, 80, upperleftx, upperlefty,
			1 :: float8 / 80,
			-2 :: float8 / 3 / 80, 0, 0, 4612),
		text '32BSI', -100, -1) rast
	FROM r1
)
SELECT ST_SetValues(rast, 1, 1, 1, dat_ary) AS rast
FROM d, r2 ;

-- page : add 12
SELECT (ST_MetaData(rast)).* FROM raster_add2 ;

-- page : add 12 (2)
SELECT ST_Quantile(rast, 1, FALSE, ARRAY[0, 1]) FROM raster_add2 ;

-- page : add 12 (3)
COPY (
	SELECT '<img width=256 height=256 src="data:image/png;base64,' ||
		replace(encode(ST_AsPNG(ST_ColorMap(rast, 'bluered')), 'base64'), E'\n', '') ||
		'" />'
	FROM raster_add2
) TO 'C:/Program Files/PostgreSQL/9.3/data/add2_output.htm' ;
