-- page : add 14
CREATE TABLE geom_add3 (jcode text, jname text, geom geometry(MULTIPOLYGON, 4612)) ;
COPY geom_add3 FROM 'C:/Program Files/PostgreSQL/9.3/data/add3_geomdata.tsv' ;

-- page : add 15
SELECT * FROM geom_add3 LIMIT 10 ;

-- page : add 15 (2)
CREATE TABLE rast_add3 AS
WITH a AS (
	SELECT 2e-003 AS res -- 𑜓x
), b AS (
	SELECT jcode, jname, floor(random() * 256) AS val, geom
	FROM geom_add3
)
SELECT jcode, jname, val,
	ST_AsRaster(geom,
		res, res * -1,	-- scalex, scaley
		res, res,	-- gridx, gridy
		'8BUI', val) AS rast
FROM a, b ;

-- page : add 15 (3)
SELECT jcode, jname, val, (ST_MetaData(rast)).* FROM rast_add3 ;

-- page : add 16
SELECT jcode, jname, val, ST_ValueCount(rast) FROM rast_add3 ;

-- page : add 16 (2)
COPY (
	WITH a AS (
		SELECT ST_AddBand(ST_Union(rast),
			ARRAY[
				ROW(1, '8BUI', 255, NULL),	-- R
				ROW(2, '8BUI', 0, NULL),	-- G
				ROW(3, '8BUI', 0, NULL)	-- B
			] :: addbandarg[]) AS rast
		FROM rast_add3
	)
	SELECT '<img src="data:image/png;base64,' ||
		replace(encode(ST_AsPNG(ST_Union(rast)), 'base64'), E'\n', '') ||
		'" />'
	FROM a
) TO 'C:/Program Files/PostgreSQL/9.3/data/add3_output_1.htm' ;

-- page : add 18
COPY (
	WITH a (res, ptype, nodata) AS (
		-- 𑜓x, sNZ^Cv, NODATAVALUE z
		VALUES (2e-003, '{8BUI, 8BUI, 8BUI, 8BUI}' :: text[], ARRAY[255, 255, 255, 0])
	), b AS (
		SELECT val, geom
		FROM geom_add3 JOIN rast_add3 USING (jcode)
	), c AS (
		SELECT ST_ExteriorRing((ST_Dump(geom)).geom) geom
		FROM geom_add3
	), d AS (
		SELECT ST_AsRaster(geom,
				res, res * -1,	-- scalex, scaley
				res, res,	-- gridx, gridy
				ptype, ARRAY[0, 155, 0, val], nodata) AS rast
		FROM a, b
		UNION ALL SELECT ST_AsRaster(geom,
				res, res * -1,	-- scalex, scaley
				res, res,	-- gridx, gridy
				ptype, ARRAY[0, 0, 0, 255], nodata)
		FROM a, c
	)
	SELECT '<img src="data:image/png;base64,' ||
		replace(encode(ST_AsPNG(ST_Union(rast)), 'base64'), E'\n', '') ||
		'" />'
	FROM d
) TO 'C:/Program Files/PostgreSQL/9.3/data/add3_output_border.htm' ;
